//+------------------------------------------------------------------+
//|                                                        Color.mq5 |
//|                                               Copyright TheXpert |
//|                                           theforexpert@gmail.com |
//+------------------------------------------------------------------+
#property copyright "TheXpert"
#property link      "theforexpert@gmail.com"
#property version   "1.00"
//---  
#property library
//---     
#define MIN_COLORS_COUNT 2
#define MAX_COLORS_COUNT 63
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
uchar R(color clr)
  {
//---     
   return(uchar)(clr & 0x0000FF);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
uchar G(color clr)
  {
//---     
   return(uchar)((clr & 0x00FF00)>>8);
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
uchar B(color clr)
  {
//---     
   return(uchar)((clr & 0xFF0000)>>16);
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
void SetR(uchar red,color &clr)
  {
   clr=color((clr & 0xFFFF00)|red);
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
void SetG(uchar green,color &clr)
  {
   clr=color((clr & 0xFF00FF)|(green<<8));
  }
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void SetB(uchar blue,color &clr)
  {
   clr=color((clr & 0x00FFFF)|(blue<<16));
  }
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
color RGB(uchar red,uchar green,uchar blue)
  {
//---  
   return red+(green<<8)+(blue<<16);
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void FillColorTable(int plotIndex,color lowerClr,color higherClr,int count /*=63*/) export
  {
//---       ,    
   if(count<MIN_COLORS_COUNT)
      count=MIN_COLORS_COUNT;
//---       ,    
   if(count>MAX_COLORS_COUNT)
      count=MAX_COLORS_COUNT;
//---    
   uchar lowerRed  =R(lowerClr);
   uchar lowerGreen=G(lowerClr);
   uchar lowerBlue =B(lowerClr);
//---    
   uchar higherRed  =R(higherClr);
   uchar higherGreen=G(higherClr);
   uchar higherBlue =B(higherClr);
//---       
   for(int i=0;i<count;++i)
     {
      //---   
      uchar currentRed  =uchar(lowerRed  +(i/double(count-1))*(higherRed  -lowerRed));
      uchar currentGreen=uchar(lowerGreen+(i/double(count-1))*(higherGreen-lowerGreen));
      uchar currentBlue =uchar(lowerBlue +(i/double(count-1))*(higherBlue -lowerBlue));
      //---   
      PlotIndexSetInteger(plotIndex,PLOT_LINE_COLOR,i,RGB(currentRed,currentGreen,currentBlue));
     }
  }
//+------------------------------------------------------------------+
