//+------------------------------------------------------------------+
//|                                              Direction_Brush.mq5 |
//|                                               Copyright TheXpert |
//|                                           theforexpert@gmail.com |
//+------------------------------------------------------------------+
#property copyright "TheXpert"
#property link      "theforexpert@gmail.com"
#property version   "1.00"
//---      
#property indicator_chart_window
//---  
#property indicator_buffers 2
#property indicator_plots   1
//--- plot 1
#property indicator_type1   DRAW_COLOR_LINE
#property indicator_color1  clrWhite,clrRed,clrBlue
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
enum EDrawType
  {
   DrawLine,
   DrawHistogram
  };
//---  
input EDrawType DrawType=DrawLine; //  
//---  
double Values[];
double Color[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//---   
   SetIndexBuffer(0,Values,INDICATOR_DATA);
   SetIndexBuffer(1,Color,INDICATOR_COLOR_INDEX);
//---    
   PlotIndexSetInteger(0,PLOT_DRAW_TYPE,DrawType==DrawLine ? DRAW_COLOR_LINE : DRAW_COLOR_HISTOGRAM);
//---       DataWindow
   PlotIndexSetInteger(0,PLOT_SHOW_DATA,false);
//---   
   IndicatorSetString(INDICATOR_SHORTNAME,"With brushed directions");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---     
   int start=prev_calculated;
//---   ,      
   if(start>0)
      start--;
   else
      start=1;
//---     
   ArrayCopy(Values,price,start,start);
//---    
   for(int i=start;i<rates_total;i++)
     {
      //---    
      Color[i]=0;
      if(Values[i]>Values[i-1])
         Color[i]=2;
      if(Values[i]<Values[i-1])
         Color[i]=1;
     }
//--- return value of prev_calculated for next call
   return rates_total;
  }
//+------------------------------------------------------------------+
